<?php
/** 
 * Function:
 *
 * reads all publications from the current pubtype list and creates an array with
 * previous and next links for browsing through the publications.
 * The first and the last link go the the list of the pubtype.
 * 
 * Usage:
 * Put <!--[pagesetter_pubBrowser]--> at the top of the pubtype-full.html template.
 * This function returns an array with 2 values:        
 * Place <!--[$nav.prev]-->, where you want the link to the previous pub be located
 * Place <!--[$nav.next]-->, where you want the link to the previous pub be located
 *
 * Author:  Thomas Smiatek
 * Email : thomas@smiatek.com
 * Revision: 1.0
 * Date:  29.06.2004
 * 
 *
 */
function smarty_function_pagesetter_pubBrowser($args, &$smarty)
{

	$core = $smarty->get_template_vars('core');
	
	if (!isset($language))
	    $language = pnUserGetLang();
	
	$pubList = pnModAPIFunc( 'pagesetter', 'user', 'getPubList', array( 'tid' => $core['tid'], 'language' => $language ) );
	
	$html = '';
	
	$counter = 0;
	$navhtml['prev'] = '<a href="index.php?module=pagesetter&tid='.$core['tid'].'" style="color: white; text-decoration: none;">&lt;&lt; zur bersicht</a>';
	$navhtml['next'] = '<a href="index.php?module=pagesetter&tid='.$core['tid'].'" style="color: white; text-decoration: none;">zur bersicht &gt;&gt;</a>';
	$foundprev = false;
	$foundnext = false;
	foreach ($pubList['publications'] as $pub)
  	{
		if (($pub['title'] != $core['title']) && ($foundprev == false))
		{
			$link = pnModURL('pagesetter','user','viewpub',array('tid' => $core['tid'], 'pid' => $pub['pid'] ));
			$navhtml['prev'] = '<a href="'.$link.'" style="color: white; text-decoration: none;">&lt;&lt; '.$pub['title'].'</a>';
		}
		if ($pub['title'] == $core['title'])
		{
			$foundprev = true;
		}
		if (($pub['title'] != $core['title']) && ($foundprev == true) && ($foundnext == false))
		{
			$foundnext = true;
			$link = pnModURL( 'pagesetter', 'user', 'viewpub', array( 'tid' => $core['tid'], 'pid' => $pub['pid'] ));
			$navhtml['next'] = '<a href="'.$link.'" style="color: white; text-decoration: none;">'.$pub['title'].' &gt;&gt;</a>';
		}
	}
	
	$smarty->assign('nav', $navhtml );
	
}
?>
